diff mbox

[v5,2/5] generic/417: Add small copies to new file test

Message ID 20170317195233.4042-3-Anna.Schumaker@Netapp.com (mailing list archive)
State New, archived
Headers show

Commit Message

Schumaker, Anna March 17, 2017, 7:52 p.m. UTC
This test copies single bytes from a source file into various new files
just to make sure that we can handle very small copies.

Signed-off-by: Anna Schumaker <Anna.Schumaker@Netapp.com>
---
 tests/generic/417     | 83 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/generic/417.out | 16 ++++++++++
 tests/generic/group   |  1 +
 3 files changed, 100 insertions(+)
 create mode 100755 tests/generic/417
 create mode 100644 tests/generic/417.out

Comments

Boaz Harrosh March 22, 2017, 4:45 p.m. UTC | #1
On 03/17/2017 09:52 PM, Anna Schumaker wrote:
> This test copies single bytes from a source file into various new files
> just to make sure that we can handle very small copies.
> 

Sorry for not following closely, but how is this supposed to work, I know that
for FSs that support it a copy_file_range is supported by clone_file_range.
But usually there are fs-block alignment restrictions on clone_file_range.

Does the VFS do the switch from fs->clone to generic-copy, or is the FS
suppose to call the generic-copy?

Thanks
Boaz

> Signed-off-by: Anna Schumaker <Anna.Schumaker@Netapp.com>
> ---
>  tests/generic/417     | 83 +++++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/generic/417.out | 16 ++++++++++
>  tests/generic/group   |  1 +
>  3 files changed, 100 insertions(+)
>  create mode 100755 tests/generic/417
>  create mode 100644 tests/generic/417.out
> 
> diff --git a/tests/generic/417 b/tests/generic/417
> new file mode 100755
> index 00000000..dde3f4d6
> --- /dev/null
> +++ b/tests/generic/417
> @@ -0,0 +1,83 @@
> +#!/bin/bash
> +# FS QA Test No. 417
> +#
> +# Tests vfs_copy_file_range():
> +#   - Copy a small file
> +#   - Small copies from various points in the original file
> +#-----------------------------------------------------------------------
> +# Copyright (c) 2016 Netapp, Inc. All rights reserved.
<snip>


--
To unsubscribe from this list: send the line "unsubscribe linux-nfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
diff mbox

Patch

diff --git a/tests/generic/417 b/tests/generic/417
new file mode 100755
index 00000000..dde3f4d6
--- /dev/null
+++ b/tests/generic/417
@@ -0,0 +1,83 @@ 
+#!/bin/bash
+# FS QA Test No. 417
+#
+# Tests vfs_copy_file_range():
+#   - Copy a small file
+#   - Small copies from various points in the original file
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Netapp, Inc. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1    # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -rf $tmp.*
+}
+
+# get standard environment
+. common/rc
+. common/filter
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+
+_require_xfs_io_command "copy_range"
+_require_test
+
+testdir=$TEST_DIR/test-$seq
+rm -rf $testdir
+mkdir $testdir
+rm -f $seqres.full
+
+echo "Create the original file and then copy"
+echo -n "abcde" > $testdir/file
+$XFS_IO_PROG -f -c "copy_range $testdir/file" "$testdir/copy"
+echo -n "abcde" | cmp $testdir/copy
+echo "Original md5sums:"
+md5sum $testdir/{file,copy} | _filter_test_dir
+
+echo "Small copies from various points in the original file"
+$XFS_IO_PROG -f -c "copy_range -s 0 -l 1      $testdir/file" "$testdir/a" 2>&1
+$XFS_IO_PROG -f -c "copy_range -s 1 -l 1      $testdir/file" "$testdir/b" 2>&1
+$XFS_IO_PROG -f -c "copy_range -s 2 -l 1      $testdir/file" "$testdir/c" 2>&1
+$XFS_IO_PROG -f -c "copy_range -s 3 -l 1      $testdir/file" "$testdir/d" 2>&1
+$XFS_IO_PROG -f -c "copy_range -s 4 -l 1      $testdir/file" "$testdir/e" 2>&1
+$XFS_IO_PROG -f -c "copy_range -s 4 -l 1 -d 1 $testdir/file" "$testdir/f" 2>&1
+$XFS_IO_PROG -f -c "copy_range -s 5 -l 1      $testdir/file" "$testdir/g" 2>&1
+echo -n "a"    | cmp $testdir/a
+echo -n "b"    | cmp $testdir/b
+echo -n "c"    | cmp $testdir/c
+echo -n "d"    | cmp $testdir/d
+echo -n "e"    | cmp $testdir/e
+echo -en "\0e" | cmp $testdir/f
+echo -n ""     | cmp $testdir/g
+echo "md5sums after small copies"
+md5sum $testdir/{file,a,b,c,d,e,f,g} | _filter_test_dir
+
+#success, all done
+status=0
+exit
diff --git a/tests/generic/417.out b/tests/generic/417.out
new file mode 100644
index 00000000..36c98478
--- /dev/null
+++ b/tests/generic/417.out
@@ -0,0 +1,16 @@ 
+QA output created by 417
+Create the original file and then copy
+Original md5sums:
+ab56b4d92b40713acc5af89985d4b786  TEST_DIR/test-417/file
+ab56b4d92b40713acc5af89985d4b786  TEST_DIR/test-417/copy
+Small copies from various points in the original file
+copy_range: Invalid argument
+md5sums after small copies
+ab56b4d92b40713acc5af89985d4b786  TEST_DIR/test-417/file
+0cc175b9c0f1b6a831c399e269772661  TEST_DIR/test-417/a
+92eb5ffee6ae2fec3ad71c777531578f  TEST_DIR/test-417/b
+4a8a08f09d37b73795649038408b5f33  TEST_DIR/test-417/c
+8277e0910d750195b448797616e091ad  TEST_DIR/test-417/d
+e1671797c52e15f763380b45e841ec32  TEST_DIR/test-417/e
+2015eb238d706eceefc784742928054f  TEST_DIR/test-417/f
+d41d8cd98f00b204e9800998ecf8427e  TEST_DIR/test-417/g
diff --git a/tests/generic/group b/tests/generic/group
index 9541fff5..57ef9d22 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -419,3 +419,4 @@ 
 414 auto quick clone
 415 auto clone
 416 auto quick copy
+417 auto quick copy